local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end

local AddonName, AddonTable = ...
local s = SpellFlashAddon
local c = BittenSpellFlashLibrary

local function flashHoly()
	if not s.InCombat() then
		return
	end
	
	c.priorityFlash(
		"white", 
		"Judgements of the Pure",
		"Word of Glory at 3", 
		"Fast Divine Light", 
		"Holy Shock")
end

local function flashProtection()
	c.flashAll("yellow", "Righteous Fury", "Seal of Insight")
	
	if not s.InCombat() then
		c.flash("Word of Glory", "pink")
		return
	end
	
	c.flash("Avenging Wrath", "pink")
	
	if c.flash("Holy Wrath to Stun") then
		return
	end
	
	c.rotateCooldowns(
		{ "Guarded by the Light", "Windwalk", "Veil of Lies" }, 
		"Holy Shield", 
		"Divine Protection", 
		"Fire of the Deep", 
		"Guardian of Ancient Kings", 
		"Ardent Defender")
	
	if c.flash("Word of Glory at 90") then
		return
	end
	
	if c.hasThreeHolyPower()
		and s.HealthPercent("player") < 90 
		and c.getCooldown("Word of Glory") < 1 then
			
		return
	end
	
	if c.priorityFlash(
		"white", 
		"Vindication", 
		"Judgements of the Just",
		"Delayed Judgement",
		"Shield of the Righteous unless WoG",
		"Crusader Strike", 
		"Avenger's Shield for Holy Power") then
		
		return
	end
	
	if c.getCooldown("Crusader Strike") < .5 then
		return
	end
	
	c.priorityFlash(
		"white",
		"Hammer of Wrath",
		"Avenger's Shield",
		"Consecration over 50",
		"Judgement",
		"Holy Wrath")
end

local function flashRetribution()
	c.flashAll("yellow", "Seal of Truth")
	
	if not s.InCombat() then
		c.flash("Word of Glory", "pink")
		return
	end

	c.flashAll("pink", "Zealotry", "Avenging Wrath")
	
	c.priorityFlash(
		"white",
		"Inquisition",
		"Crusader Strike for Holy Power",
		"Free Exorsism against Undead",
		"Hammer of Wrath",
		"Free Exorsism",
		"Templar's Verdict",
		"Crusader Strike",
		"Judgement",
		"Holy Wrath",
		"Consecration over 50",
		"Divine Plea")
end

s.Spam[AddonName] = function()
	if s.GetModuleConfig(AddonName, "spell_flashing_off") then 
		return
	end
	
	c.gcdSpell = "Cleanse"
	c.spells = AddonTable.Spells
	c.addonName = AddonName
	c.run(flashHoly, 1, "holy_off")
	c.run(flashProtection, 2, "prot_off")
	c.run(flashRetribution, 3, "ret_off")
end
